#!/usr/bin/python
# coding=utf8

from __future__ import division

### Audio-Modul

import pyaudio

##############

# Graphik und Berechnungen

import matplotlib

### Wir müssen uns hier für ein Graphik-System ('backend') entscheiden,
### wenn wir dieses die Ereigniskontroll übernehmen lassen wollen: 'gtk'

matplotlib.use('GTKAgg')
import gobject

import matplotlib.pyplot as plt

import numpy as np

###  Zeit

import time

###########################

### GLOBALE VARIABLEN

CHANNELS=1
RATE=44100
DAUER=1
ANZAHL=DAUER*RATE # ANZAHL der Frames,
CHUNK=2**11

# globale Variablen, schlechter Programmierstil, hier aber ganz
# praktisch: Nach Aufnahme oder Lesen werden diese Variablen 
# entsprechend gesetzt.

########################################


class Anzeige(object):
	'''Anzeige-Objekt, zeigt 'chunk' frames
	an, x-Achse beschriftet mit den korrekten Zeiten.
	Das zweite Argument ist die Sample-Rate'''
	def __init__(self,chunk,rate):
		self.fig,self.ax=plt.subplots(1,1)  
		self.ax = plt.axes(ylim=(-1,1),xlim=(0,chunk/RATE))
		self.xwerte=np.arange(chunk)/RATE
		
		self.kurve, = self.ax.plot(self.xwerte,np.zeros(chunk), lw=2)
		self.fig.canvas.draw()
		plt.pause(0.001)
		self.chunk=chunk
		

	def update(self,data):
		'''Plottet 'data' '''
		self.kurve.set_data(self.xwerte,data/2**16)
			
	def zeichnen(self,*args):
		self.fig.canvas.draw()
		return True

##################

### Anzeige setup, hier wird das 'idle'-Event (=nichts weiter
### zu tun) mit dem Zeichnen des momentanen Plots verbunden


anzeige=Anzeige(CHUNK,RATE)
gobject.idle_add(anzeige.zeichnen)

### Audio setup ###########################################

###  Hier wird ein 'Audio-Stream' gestartet, der immer, wenn
### CHUNK  Frames aus dem Mikrophon gelesen wurden, die Funktion
### micro_callback aufruft, die diese Daten dann in den Plot
### 'anzeige' schreibt. Stattdessen könnte man die Daten auch 
### erste bearbeiten und irgendwoanders hin schreiben.
### Dieser Audiostream läuft unabhängig vom weiteren Programm.
### Die Daten in anzeige.kurve sind also stets aktuell.
### Ums Anzeigen kümmert sich dann 'gtk'.

##############################################################


def micro_callback(in_data, frame_count, time_info, status):
	'''callback Funktion: wird vom PyAudio-Objekt aufgerufen,
	wenn CHUNK Frames von der Soundkarte (Mikrophon) gelesen wurden'''
	y=np.fromstring(in_data,dtype=np.short)
	if CHANNELS==2:
		y=y.reshape((y.shape[0]//2,2))
	else:
		y=y.reshape((y.shape[0],1))
	anzeige.update(y[:,0])
	return (in_data, pyaudio.paContinue)


p = pyaudio.PyAudio()
stream = p.open(format=pyaudio.paInt16 ,
                channels=CHANNELS,
                rate=RATE,
                input=True,
                output=False,
                stream_callback=micro_callback,
                frames_per_buffer=CHUNK)

stream.start_stream()
time.sleep(0.5)

#################################################

###  durch diesen Aufruf wird nicht nur angezeigt, was
### anzuzeigen ist, sondern auch die Ereignis-Verarbeitung
### von gtk gestartet, eine Endlosschleife, die beim Ausbleiben
### sonstiger Ereignisse den Graphen mit den aktuellen Daten
### neu zeichnet (siehe oben, idle_add(...) )
### Die Schleife wird erst verlassen, wenn wir das Graphik-Fenster
### schließen.

plt.show()

#### Alles wieder schließen, was geöffnet wurde

    
stream.stop_stream()
stream.close()
p.terminate()
